<?
// Author: Joshua Uziel
// Copyright 2001, Sun Microsystems, Inc.  All rights reserved.
// $Id: ups_details.php,v 1.7 2001/11/16 01:27:38 uzi Exp $

include("ServerScriptHelper.php");
include("base/am/am_detail.inc");

$helper = new ServerScriptHelper();
$cce = $helper->getCceClient();
$factory = $helper->getHtmlComponentFactory("base-ups");
$page = $factory->getPage();
$i18n = $factory->i18n;

print($page->toHeaderHtml());

am_detail_block($factory, $cce, "UPS", "[[base-ups.amUPSDetails]]");

// Get the sub block
$subblock = $factory->getPagedBlock(
	$i18n->interpolate("[[base-ups.amUPSStats]]"));

// Battery level
$HOST = `grep HOST= /etc/sysconfig/ups | sed -e 's/.*=//'`;
$HOST = chop($HOST);
$pct = `/usr/bin/upsc $HOST | grep BATTPCT | sed -e 's/.*: //' -e 's/\..*//' -e 's/^0*//'`;
$battpct = "[[base-ups.amUPSBattPct,val=$pct]]";
$subblock->addFormField(
	$factory->getTextField("battlevel", $i18n->interpolate($battpct), "r"),
	$factory->getLabel("amUPSBattLevel", true)
);

// Status
$status = `/usr/bin/upsc $HOST | grep STATUS | sed -e 's/.*: //'`;
$status = chop($status);

// Get into separate tokens of values, since there can be more than
// one at a time.
$mystatus = "";
$tok = strtok($status," ");
while ($tok) {
	$mystatus .= "[[base-ups.amUPSStatus$tok]] ";
	$tok = strtok (" ");
}

$subblock->addFormField(
	$factory->getTextField("status", $i18n->interpolate($mystatus), "r"),
	$factory->getLabel("amUPSStatus", true)
);

// print it if we were able to read the status
if ($status) {
	print("<br>");
	print($subblock->toHtml());
	// reload page every 60 seconds, so we have up to date battery stats
    print("<SCRIPT LANGUAGE=\"javascript\">	
       setTimeout(\"location.reload(true)\", 60000); </SCRIPT>");
}

am_back($factory);

print($page->toFooterHtml());

$helper->destructor();

?>
